/*
 * segatex SELinux tool.
 *
 * Copyright (C) 2007-2013 Shintaro Fujiwara 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * */
#ifndef SEGATEXCORE_H
#define SEGATEXCORE_H

#include <qregexp.h>
#include <qdialog.h>
#include <qradiobutton.h>
#include <q3textedit.h>


class QLayout;
class QCheckBox;
class Q3TextEdit;
class QLineEdit;
class QPushButton;
class Q3Process;
class SegatexCoreProcess;
class SegatexCore2Process;

class SegatexCore: public QDialog
{
	Q_OBJECT
public:
	SegatexCore(QWidget *parent = 0, const char *name = 0);
private slots:
	void segatex_core_clicked();
	void segatex_core2_clicked();
private:
        QCheckBox *lastreloadCheckBox;
        QCheckBox *requiresCheckBox;
        QCheckBox *referenceCheckBox;
        QCheckBox *verboseCheckBox;
        QCheckBox *explainCheckBox;
        QPushButton *segatex_coreButton;
        QPushButton *segatex_core2Button;
        QPushButton *closeButton;
        SegatexCoreProcess *segatex_core_process;
        SegatexCore2Process *segatex_core2_process;
};

#endif
